*** interface.c.orig	Fri Aug  6 03:39:24 2004
--- interface.c	Fri Aug  6 04:06:55 2004
***************
*** 85,95 ****
      if ((fd = open(ctrlrpath(unit), 0)) < 0)
  	return;
      
!     for (i = -1; ;) {
  	/* Get the unit number of the next child device */
! 	if (ioctl(fd, MLX_NEXT_CHILD, &i) < 0)
! 	    return;
! 	
  	/* check that we can open this unit */
  	if ((fd = open(drivepath(i), 0)) >= 0)
  	    close(fd);
--- 85,97 ----
      if ((fd = open(ctrlrpath(unit), 0)) < 0)
  	return;
      
!     for (i = 0; i < 64 ; i++) {
  	/* Get the unit number of the next child device */
!         /* Here, this always sets i to 0, instead of iterating over */
!         /* devices.  As A work-around, I have hard-coded a loop     */
!         /* from 0 to 64.  ...sandy                                  */
! 	/* if (ioctl(fd, MLX_NEXT_CHILD, &i) < 0)  */
! 	/*  return;                                */
  	/* check that we can open this unit */
  	if ((fd = open(drivepath(i), 0)) >= 0)
  	    close(fd);
***************
*** 128,137 ****
      
      /* Get the device */
      if ((fd = open(ctrlrpath(unit), 0)) >= 0) {
! 	for (i = -1; ;) {
  	    /* Get the unit number of the next child device */
! 	    if (ioctl(fd, MLX_NEXT_CHILD, &i) < 0)
! 		break;
  
  	    /* is this child the unit we want? */
  	    if (i == mlxd_find_ctrlr_param.unit) {
--- 130,144 ----
      
      /* Get the device */
      if ((fd = open(ctrlrpath(unit), 0)) >= 0) {
! 	for (i = 0; i < 64 ; i++) {
!     /*  for (i = -1; ;){                                         */
  	    /* Get the unit number of the next child device */
!             /* This sets i to 0 and never returns -1.            */
!             /* Therefore, the for loop never completes.          */
! 	    /* As a work-around, I simply loop from from 0 to 64 */
! 	    /* looking for controllers. ...sandy                 */
! 	  /* if (ioctl(fd, MLX_NEXT_CHILD, &i) < 0)              */
! 	  /*	break;                                           */
  
  	    /* is this child the unit we want? */
  	    if (i == mlxd_find_ctrlr_param.unit) {